library(rgdal);library(ggplot2);library(plyr);library(RColorBrewer);library(packrat);library(sp);
library(dplyr);library(rgeos);library(ggrepel);library(sp);library(raster);library(shinytest);
library(scales);library(OpenStreetMap);library(rJava);library(OpenStreetMap);library(reshape2);
library(shiny);library(shinythemes);library(plotly); library(shinydashboard); library(htmlTable);

#set working directory
setwd("~/Logan")

Alcohol_Drugs=data.frame(LONG=c(153.14427,153.119088,153.1027395,153.128493,153.096525,153.2106495), 
                         LAT=c(-27.601038,-27.643167,-27.640602,-27.613341,-27.766557,-27.703512),
                         Service_Name=c("Discipleship House","SHIFT","Addiction Services (Intervention) - includes outreach", 
                                        "Alcohol & other drugs Community Liaison Service","Logan House Rehab",
                                        "Drug & Alcohol Services"))
write.csv(Alcohol_Drugs, file = "Alcohol_Drugs.csv")

Child_Family=data.frame(LONG=c(153.182682,153.119088,153.119088,153.182682,153.182682,153.1387665,153.1387665,153.1387665,
                               153.114795,153.1387665,153.132858,153.11142,153.128493,153.1082648,153.1082648,153.1082648,
                               153.182682,153.0445725,153.209673,153.1956284,153.2044755,153.117045,153.043038,153.105102,153.1168352),
                        LAT=c(-27.672993,-27.643167,-27.643167,-27.672993,-27.672993,-27.649206,-27.649206,-27.649206,
                              -27.622737,-27.649206,-27.64089,-27.617634,-27.613341,-27.63625318,-27.63625318,-27.63625318,
                              -27.672993,-27.66348,-27.701298,-27.713792,-27.716823,-27.659808,-27.66429,-27.637164,-27.64242006),
                        Service_Name=c("Beenleigh Family and Child Connect","Step by Step","Intensive Family Support", 
                                       "Child_Family Well-being","Family and Child Connect (FACC) - Logan","Counselling",
                                       "The Family Hub","Family Support Program","Recognised Entity (Child Protection)", 
                                       "HIPPY","Communities for Children","The Family Unit","KNIT - Knowledge, Networking, Intervention, Training",
                                       "Family Intervention Service","Intensive Family Support Service Logan","Supporting Children After Separation Program", 
                                       "Intensive Family Support","Family and Child Connect - Browns Plains","Training and Family Support",
                                       "Communities for Children - Eagleby Family Centre Hub","Beenleigh Child Safety Centre","Loganlea Child Safety Centre", 
                                       "Brown Plains Child Safety Centre","Logan Central Child Safety Centre","Child_Family services"))
write.csv(Child_Family, file = "Child_Family.csv")

Domestic_Family_Violence=data.frame(LONG=c(153.119088,153.119088,153.1104255,153.106906,153.104121,153.1104255,153.1257795,153.108837),
                                    LAT=c(-27.643167,-27.643167,-27.641745,-27.63883,-27.643923,-27.641745,-27.609822,-27.633798),
                                    Service_Name=c("Responsible Men","R4Respect","Women at Risk","Perpetrator intervention program, community mentoring and sporting partnerships", 
                                                   "Rise up be yourself  (RUBY)","99 Steps","Murri Sisters","Counselling Services"))
write.csv(Domestic_Family_Violence, file = "Domestic_Family_Violence.csv")

Employment=data.frame(LONG=c(153.119088,153.1064284,153.2015415,153.1088595,153.1982565,153.1387665,153.107289,153.103887),
                      LAT=c(-27.643167,-27.63982312,-27.714834,-27.640431,-27.717498,-27.649206,-27.639351,-27.63702),
                      Service_Name=c("ParentsNEXT","ParentsNEXT","ParentsNEXT","ParentsNEXT","ParentsNEXT",
                                     "Skilling Queenslanders for Work - Build a Secure Future","Transition to work", 
                                     "Skilling Queenslanders for Work"))
write.csv(Employment, file = "Employment.csv")

Finance=data.frame(LONG=c(153.119088,153.119088,153.119088,153.182682), LAT=c(-27.643167,-27.643167,-27.643167,-27.672993),
                   Service_Name=c("Financial Counselling","Gambling Financial Counselling","Moneysmart","Saver Plus Program"))
write.csv(Finance, file = "Finance.csv")

Health_Social_Connection_Wellbeing=data.frame(LONG=c(153.1387665,153.1387665), LAT=c(-27.649206,-27.649206),
                                              Service_Name=c("Community Development","Older Persons Action Program"))
write.csv(Health_Social_Connection_Wellbeing, file = "Health_Social_Connection_Wellbeing.csv")

Housing_Homelessness=data.frame(LONG=c(153.14427,153.119088,153.097578,153.1387665,153.1956284,153.1901835,153.1483695,153.103887),
                                LAT=c(-27.601038,-27.643167,-27.633411,-27.649206,-27.713792,-27.7137,-27.704727,-27.63702),
                                Service_Name=c("Homelessness Outreach","Housing 1st","Bridges Reconnect","Immediate Supported Accommodation (ISA)",
                                               "Specialist Youth Housing Service","In- SYNC","Sheltered Accommodation","NAYSS"))
write.csv(Housing_Homelessness, file = "Housing_Homelessness.csv")

Information_Advice_Referral=data.frame(LONG=c(153.119088,153.1088595), LAT=c(-27.643167,-27.640431),
                                       Service_Name=c("YFS Connect","Gateway"))
write.csv(Information_Advice_Referral, file = "Information_Advice_Referral.csv")

Legal=data.frame(LONG=c(153.120663,153.119088,153.1083492,153.1420415), LAT=c(-27.613503,-27.643167,-27.63509918,-27.70845275))
write.csv(Legal, file = "Legal.csv")

Mental_Health=data.frame(LONG=c(153.139032,153.182682,153.139032,153.115515), LAT=c(-27.668178,-27.672993,-27.668178,-27.609579))
write.csv(Mental_Health, file = "Mental_Health.csv")

Migrant_Refugee=data.frame(LONG=c(153.103887,153.103887,153.1104255,153.1104255,153.130599), LAT=c(-27.63702,-27.63702,-27.641745,-27.641745,-27.625059))
write.csv(Migrant_Refugee, file = "Migrant_Refugee.csv")

Sexual_Assault_Abuse= data.frame(LONG=c(153.109071,153.109071), LAT=c(-27.642825,-27.642825))
write.csv(Sexual_Assault_Abuse, file = "Sexual_Assault_Abuse.csv")

Youth=data.frame(LONG=c(153.119088,153.104121,153.1105425), LAT=c(-27.643167,-27.643923,-27.641988))
write.csv(Youth, file = "Youth.csv")

Secondary=data.frame(LONG=c(153.182682,153.119088,153.139032,153.119088,153.119088,153.119088,153.1064284,
                            153.2015415,153.182682,153.182682,153.1088595,153.1982565,153.119088,153.1387665,
                            153.1387665,153.1387665,153.11142,153.103887,153.103887,153.128493,153.103887,
                            153.1082648,153.104121,153.1901835,153.1105425,153.1088595,153.1104255,153.130599),
                     LAT=c(-27.672993,-27.643167,-27.668178,-27.643167,-27.643167,-27.643167,-27.63982312,-27.714834,-27.672993,
                           -27.672993,-27.640431,-27.717498,-27.643167,-27.649206,-27.649206,-27.649206,-27.617634,-27.63702,
                           -27.63702,-27.613341,-27.63702,-27.63625318,-27.643923,-27.7137,-27.641988,-27.640431,-27.641745,-27.625059))
write.csv(Secondary, file = "Secondary.csv")

Early_Intervention_Prevention= data.frame(LONG=c(153.1387665,153.1387665,153.1387665,153.1387665,153.132858,153.119088,153.182682,153.1956284),
                                          LAT=c(-27.649206,-27.649206,-27.649206,-27.649206,-27.64089,-27.643167,-27.672993,-27.713792))
write.csv(Early_Intervention_Prevention, file = "Early_Intervention_Prevention.csv")

Tertiary=data.frame(LONG=c(153.14427,153.14427,153.139032,153.182682,153.119088,153.119088,153.119088,153.119088,153.119088,153.120663,
                           153.119088,153.097578,153.115515,153.114795,153.109071,153.1387665,153.1956284,153.119088,153.107289,153.1082648,
                           153.1082648,153.182682,153.1104255,153.1104255,153.209673,153.106906,153.104121,153.1083492,153.1104255,153.1257795,
                           153.1420415,153.108837,153.109071,153.1027395,153.128493,153.096525,153.1483695,153.2106495,153.103887,153.2044755,
                           153.117045,153.043038,153.105102,153.1168352),
                    LAT=c(-27.601038,-27.601038,-27.668178,-27.672993,-27.643167,-27.643167,-27.643167,-27.643167,-27.643167,-27.613503,
                          -27.643167,-27.633411,-27.609579,-27.622737,-27.642825,-27.649206,-27.713792,-27.643167,-27.639351,-27.63625318,
                          -27.63625318,-27.672993,-27.641745,-27.641745,-27.701298,-27.63883,-27.643923,-27.63509918,-27.641745,-27.609822,
                          -27.70845275,-27.633798,-27.642825,-27.640602,-27.613341,-27.766557,-27.704727,-27.703512,-27.63702,-27.716823,-27.659808,
                          -27.66429,-27.637164,-27.64242006))
write.csv(Tertiary, file = "Tertiary.csv")


#read service location data
services<-read.csv("data/Raw_File_Mapping_Feb19.csv")
#set as data frame
services<-as.data.frame(services)

#read in ABS sa2 shape file 2016 sa2
sa2<-readOGR(dsn=path.expand("./data/shape_files"), layer="SA2_2016_AUST")
qld_sa2<-sa2[sa2$SA2_NAME16 %in%c("Alexandra Hills","Belmont - Gumdale","Birkdale","Capalaba","Thorneside",
                                  "Wellington Point","Cleveland","Ormiston","Redland Bay","Sheldon - Mount Cotton",
                                  "Thornlands","Victoria Point","Redland Islands","Brisbane Port - Lytton",
                                  "Manly - Lota","Manly West","Murarrie","Tingalpa","Wakerley","Wynnum",
                                  "Wynnum West - Hemmant","Bald Hills","Bridgeman Downs","Carseldine",
                                  "Everton Park","McDowall","Aspley","Chermside","Chermside West",
                                  "Geebung","Kedron - Gordon Park","Stafford","Stafford Heights",
                                  "Wavell Heights","Boondall","Brisbane Airport","Eagle Farm - Pinkenba",
                                  "Northgate - Virginia","Nudgee - Banyo","Nundah","Bracken Ridge",
                                  "Brighton (Qld)","Deagon","Sandgate - Shorncliffe","Taigum - Fitzgibbon",
                                  "Zillmere","Camp Hill","Cannon Hill","Carina","Carina Heights","Carindale",
                                  "Annerley","Coorparoo","Fairfield - Dutton Park","Greenslopes","Holland Park",
                                  "Holland Park West","Woolloongabba","Yeronga","Eight Mile Plains","Macgregor (Qld)",
                                  "Mansfield (Qld)","Mount Gravatt","Rochedale - Burbank","Upper Mount Gravatt","Wishart",
                                  "Coopers Plains","Moorooka","Robertson","Salisbury - Nathan","Tarragindi","Algester",
                                  "Calamvale - Stretton","Pallara - Willawong","Parkinson - Drewvale",
                                  "Rocklea - Acacia Ridge","Kuraby","Runcorn","Sunnybank","Sunnybank Hills",
                                  "Jindalee - Mount Ommaney","Middle Park - Jamboree Heights","Riverhills",
                                  "Seventeen Mile Rocks - Sinnamon Park","Westlake","Bellbowrie - Moggill",
                                  "Brookfield - Kenmore Hills","Chapel Hill","Fig Tree Pocket","Kenmore",
                                  "Pinjarra Hills - Pullenvale","Chelmer - Graceville","Corinda","Indooroopilly",
                                  "Sherwood","St Lucia","Taringa","Enoggera","Enoggera Reservoir","Keperra","Mitchelton",
                                  "Mount Coot-tha","The Gap","Upper Kedron - Ferny Grove","Brisbane City",
                                  "Fortitude Valley","Highgate Hill","Kangaroo Point","New Farm","South Brisbane",
                                  "Spring Hill","West End","Balmoral","Bulimba","East Brisbane","Hawthorne",
                                  "Morningside - Seven Hills","Norman Park","Albion","Alderley","Ascot","Clayfield",
                                  "Grange","Hamilton (Qld)","Hendra","Kelvin Grove - Herston","Newmarket","Newstead - Bowen Hills",
                                  "Wilston","Windsor","Wooloowin - Lutwyche","Ashgrove","Auchenflower","Bardon",
                                  "Paddington - Milton","Red Hill (Qld)","Toowong","Brinsmead","Clifton Beach - Kewarra Beach",
                                  "Freshwater - Stratford","Redlynch","Trinity Beach - Smithfield","Yorkeys Knob - Machans Beach",
                                  "Bentley Park","Cairns City","Earlville - Bayview Heights","Edmonton","Gordonvale - Trinity",
                                  "Kanimbla - Mooroobool","Lamb Range","Manoora","Manunda","Mount Sheridan","Westcourt - Bungalow",
                                  "White Rock","Whitfield - Edge Hill","Woree","Babinda","Innisfail","Johnstone","Tully",
                                  "Wooroonooran","Yarrabah","Daintree","Port Douglas","Atherton","Herberton","Kuranda",
                                  "Malanda - Yungaburra","Mareeba","Balonne","Chinchilla","Goondiwindi","Inglewood - Waggamba",
                                  "Miles - Wandoan","Roma","Roma Region","Tara","Crows Nest - Rosalie","Jondaryan","Millmerran",
                                  "Pittsworth","Wambo","Clifton - Greenmount","Southern Downs - East","Southern Downs - West",
                                  "Stanthorpe","Stanthorpe Region","Warwick","Central Highlands - East","Central Highlands - West",
                                  "Emerald","Berserker","Bouldercombe","Emu Park","Frenchville - Mount Archer","Glenlee - Rockyview",
                                  "Gracemere","Lakes Creek","Mount Morgan","Norman Gardens","Park Avenue","Parkhurst - Kawana",
                                  "Rockhampton - West","Rockhampton City","Rockhampton Region - East","Rockhampton Region - North",
                                  "Rockhampton Region - West","Shoalwater Bay","The Range - Allenstown","Yeppoon","Banana","Biloela",
                                  "Agnes Water - Miriam Vale","Boyne Island - Tannum Sands","Callemondah","Clinton - New Auckland",
                                  "Gladstone","Gladstone Hinterland","Kin Kora - Sun Valley","South Trees","Telina - Toolooa",
                                  "West Gladstone","Broadbeach Waters","Burleigh Heads","Burleigh Waters","Mermaid Beach - Broadbeach",
                                  "Mermaid Waters","Miami","Coolangatta","Currumbin - Tugun","Currumbin Waters","Elanora","Palm Beach",
                                  "Arundel","Biggera Waters","Coombabah","Labrador","Paradise Point - Hollywell","Runaway Bay",
                                  "Guanaba - Springbrook","Tamborine - Canungra","Currumbin Valley - Tallebudgera","Mudgeeraba - Bonogin",
                                  "Reedy Creek - Andrews","Carrara","Highland Park","Nerang - Mount Nathan","Pacific Pines - Gaven",
                                  "Worongary - Tallai","Coomera","Helensvale","Hope Island","Jacobs Well - Alberton","Ormeau - Yatala",
                                  "Oxenford - Maudsland","Pimpama","Upper Coomera - Willow Vale","Clear Island Waters","Merrimac","Robina",
                                  "Varsity Lakes","Ashmore","Molendinar","Parkwood","Southport - North","Southport - South","Benowa",
                                  "Bundall","Main Beach","Surfers Paradise","Darra - Sumner","Durack","Forest Lake - Doolandella",
                                  "Inala - Richlands","Oxley (Qld)","Wacol","Boonah","Esk","Lake Manchester - England Creek",
                                  "Lockyer Valley - East","Lowood","Rosewood","Brassall","Bundamba","Churchill - Yamanto",
                                  "Ipswich - Central","Ipswich - East","Ipswich - North","Karalee - Barellan Point","Karana Downs",
                                  "Leichhardt - One Mile","North Ipswich - Tivoli","Raceview","Ripley","Riverview",
                                  "Bellbird Park - Brookwater","Camira - Gailes","Carole Park","Collingwood Park - Redbank",
                                  "Goodna","New Chum","Redbank Plains","Springfield","Springfield Lakes","Beaudesert","Beenleigh",
                                  "Eagleby","Edens Landing - Holmview","Mount Warren Park","Wolffdene - Bahrs Scrub",
                                  "Boronia Heights - Park Ridge","Browns Plains","Chambers Flat - Logan Reserve","Crestmead",
                                  "Greenbank Military Camp","Hillcrest","Marsden","Munruben - Park Ridge South","Regents Park - Heritage Park",
                                  "Greenbank","Jimboomba","Logan Village","Bethania - Waterford","Cornubia - Carbrook","Loganholme - Tanah Merah",
                                  "Loganlea","Shailer Park","Waterford West","Daisy Hill","Kingston (Qld.)","Logan Central",
                                  "Rochedale South - Priestdale","Slacks Creek","Springwood","Underwood","Woodridge","Bowen","Broadsound - Nebo",
                                  "Clermont","Collinsville","Moranbah","Andergrove - Beaconsfield","East Mackay","Eimeo - Rural View",
                                  "Eungella Hinterland","Mackay","Mackay Harbour","Mount Pleasant - Glenella","North Mackay","Ooralea - Bakers Creek",
                                  "Pioneer Valley","Sarina","Seaforth - Calen","Shoal Point - Bucasia","Slade Point","South Mackay","Walkerston - Eton",
                                  "West Mackay","Airlie - Whitsundays","Cape Conway","Proserpine","Beachmere - Sandstone Point","Bribie Island",
                                  "Burpengary - East","Caboolture","Caboolture - South","Elimbah","Morayfield - East","Wamuran","Kilcoy",
                                  "Woodford - D'Aguilar","Burpengary","Deception Bay","Morayfield","Narangba","Upper Caboolture","Clontarf",
                                  "Margate - Woody Point","Redcliffe","Rothwell - Kippa-Ring","Scarborough - Newport - Moreton Island","Albany Creek",
                                  "Cashmere","Dayboro","Eatons Hill","The Hills District","Samford Valley","Dakabin - Kallangur",
                                  "Murrumba Downs - Griffin","North Lakes - Mango Hill","Bray Park","Lawnton","Petrie","Strathpine - Brendale",
                                  "Aurukun","Cape York","Croydon - Etheridge","Kowanyama - Pormpuraaw","Northern Peninsula","Tablelands","Torres",
                                  "Torres Strait Islands","Weipa","Carpentaria","Mount Isa","Mount Isa Region","Northern Highlands",
                                  "Barcaldine - Blackall","Charleville","Far Central West","Far South West","Longreach","Buderim - North",
                                  "Buderim - South","Mountain Creek","Sippy Downs","Aroona - Currimundi","Buddina - Minyama","Caloundra - Kings Beach",
                                  "Caloundra - West","Golden Beach - Pelican Waters","Moffat Beach - Battery Hill","Parrearra - Warana",
                                  "Wurtulla - Birtinya","Coolum Beach","Marcoola - Mudjimba","Maroochydore - Kuluin","Mooloolaba - Alexandra Headland",
                                  "Noosa Heads","Noosaville","Sunshine Beach","Tewantin","Peregian Beach - Marcus Beach","Peregian Springs",
                                  "Beerwah","Caloundra Hinterland","Glass House Mountains","Landsborough","Maroochy Hinterland","Palmwoods",
                                  "Bli Bli","Diddillibah - Rosemount","Eumundi - Yandina","Nambour","Noosa Hinterland","Cambooya - Wyreema",
                                  "Darling Heights","Drayton - Harristown","Gatton","Gowrie (Qld)","Highfields","Lockyer Valley - West",
                                  "Middle Ridge","Newtown (Qld)","North Toowoomba - Harlaxton","Rangeville","Toowoomba - Central","Toowoomba - East",
                                  "Toowoomba - West","Wilsonton","Ayr","Burdekin","Charters Towers","Dalrymple","Ingham","Ingham Region","Palm Island",
                                  "Aitkenvale","Annandale","Belgian Gardens - Pallarenda","Bohle Plains","Condon - Rasmussen","Cranbrook","Deeragun",
                                  "Douglas","Garbutt - West End","Gulliver - Currajong - Vincent","Heatley","Hermit Park - Rosslea",
                                  "Hyde Park - Pimlico","Kelso","Kirwan - East","Kirwan - West","Magnetic Island","Mount Louisa","Mundingburra",
                                  "Northern Beaches","Oonoonba","South Townsville - Railway Estate","Townsville - South","Townsville City - North Ward",
                                  "Wulguru - Roseneath","Ashfield - Kepnock","Bargara - Burnett Heads","Branyan - Kensington","Bundaberg",
                                  "Bundaberg East - Kalkie","Bundaberg North - Gooburrum","Bundaberg Region - North","Bundaberg Region - South",
                                  "Millbank - Avoca","Svensson Heights - Norville","Walkervale - Avenell Heights","Gayndah - Mundubbera","Gin Gin",
                                  "Kingaroy","Kingaroy Region - North","Kingaroy Region - South","Monto - Eidsvold","Nanango","North Burnett",
                                  "Cooloola","Gympie - North","Gympie - South","Gympie Region","Kilkivan","Booral - River Heads",
                                  "Craignish - Dundowran Beach","Pialba - Eli Waters","Point Vernon","Torquay - Scarness - Kawungan",
                                  "Urangan - Wondunna","Burrum - Fraser","Granville","Maryborough (Qld)","Maryborough Region - South","Tinana"),]

#filter to only have the Sa2s in Logan as per the Logan Togther map
logan_sa2<-sa2[sa2$SA2_NAME16 %in% c( "Jimboomba","Marsden","Regents Park - Heritage Park", "Arundel", 
                                      "Crestmead","Rochedale South - Priestdale","Woodridge", "Eight Mile Plains",
                                      "Eagleby","Greenbank","Loganholme - Tanah Merah","Boronia Heights - Park Ridge",
                                      "Kingston (Qld.)","Loganlea","Slacks Creek","Bethania - Waterford",
                                      "Shailer Park","Edens Landing - Holmview","Browns Plains",
                                      "Hillcrest","Springwood","Waterford West","Underwood","Beenleigh",
                                      "Cornubia - Carbrook","Logan Central","Daisy Hill","Wolffdene - Bahrs Scrub",
                                      "Logan Village","Mount Warren Park", "Greenbank Military Camp",
                                      "Chambers Flat - Logan Reserve","Munruben - Park Ridge South", "Rochedale - Burbank", "Sheldon - Mount Cotton"),]
#get the centres of the polygons for labelling purposes
logan_centre <- data.frame(gCentroid(logan_sa2)) 
centroids <- as.data.frame(coordinates(logan_sa2))
names(centroids) <- c("long", "lat")#capture the lat longs for the centres of each elctoral division
centroids$SA2_NAME16 <- factor(logan_sa2$SA2_NAME16)#add the elect_divs to the centroids data    



coordinates(services) <- ~ Longitude + Latitude
proj4string(services) <- proj4string(logan_sa2)
a.data <- over(services, logan_sa2[,"SA2_NAME16"])
services$SA2_NAME16 <- a.data$SA2_NAME16
DF <- as.data.frame(services)

write.csv(DF, file = "Logan_Service_Locations.csv")



#pal2<-colorFactor(c("#a792e4", # housing = light purple
#                   "#0e70f1", #mental health = medium blue
#                  "#da74e4", # family = pink
#                 "#1d8f8f", # finance = teal
#                "#4a48b6", # youth = dark purple
#               "#e28a3f", #employment = orange
#              "#90c6a6", #employment = light green
#             "#e27d3f", #legal = orange
#            "#ea2525", #family violence = red
#           "#e2c920", #information = yellow
#          "#33a4bf", # sexual abuse = light blue
#         "#421076", #wellbeing = dark purple (logan purple)
#        "#7b0c22"), domain = service_types) #refugee = dark red, domain = service_types)


#service_colours<-c("#a792e4", # housing = light purple
#                  "#0e70f1", #mental health = medium blue
#                 "#da74e4", # family = pink
#                "#1d8f8f", # finance = teal
#               "#4a48b6", # youth = dark purple
#              "#e28a3f", #employment = orange
#             "#90c6a6", #employment = light green
#            "#e27d3f", #legal = orange
#           "#ea2525", #family violence = red
#          "#e2c920", #information = yellow
#         "#33a4bf", # sexual abuse = light blue
#        "#421076", #wellbeing = dark purple (logan purple)
#       "#7b0c22") #refugee = dark red





#


# the following does not work and is an attempt to clear the map when nothing
# is selected. Tried 'length(input$toshow)==0' etc.
observeEvent(input$type, {
  
  proxy <- leafletProxy('map')
  
  if(length(input$type)==0){ leafletProxy('map') %>% removeMarker(layerId = logan_sa2$SA2_NAME16) }
})

# Then for every value of the variable, create add/remove rules
observeEvent(input$type, {
  
  proxy <- leafletProxy('map')
  
  if("Housing_Homelessness" %in% input$type){
    proxy %>% addMarkers(layerId = logan_sa2$SA2_NAME16[services$Service_Type=="Housing_Homelessness"],
                         services$Longitude[services$Service_Type=="Housing_Homelessness"],services$Latitude[services$Service_Type=="Housing_Homelessness"],
                         group = 'myicons'
    )
  }
  
  if(!("Housing_Homelessness" %in% input$type)){
    proxy %>% clearMarkers(layerId = logan_sa2$SA2_NAME1[services$Service_Type=="Housing_Homelessness"])
  }
  
  
})

observeEvent(input$type, {
  
  proxy <- leafletProxy('map')
  
  if("Mental_Health" %in% input$type){
    proxy %>% addMarkers(layerId = logan_sa2$SA2_NAME16[services$Service_Type=="Mental_Health"],
                         services$Longitude[services$Service_Type=="Mental_Health"],services$Latitude[services$Service_Type=="Mental_Health"],
                         group = 'myicons'
    )
  }
  
  if(!("Mental_Health" %in% input$type)){
    proxy %>% removeMarker(layerId = logan_sa2$SA2_NAME1[services$Service_Type=="Mental_Health"])
  }
  
  
})

observeEvent(input$type, {
  
  proxy <- leafletProxy('map')
  
  if("Child_Family" %in% input$type){
    proxy %>% addMarkers(layerId = logan_sa2$SA2_NAME16[services$Service_Type=="Child_Family"],
                         services$Longitude[services$Service_Type=="Child_Family"],services$Latitude[services$Service_Type=="Child_Family"],
                         group = 'myicons'
    )
  }
  
  if(!("Child_Family" %in% input$type)){
    proxy %>% removeMarker(layerId = logan_sa2$SA2_NAME1[services$Service_Type=="Child_Family"])
  }
  
  
})


checkboxGroupButtons(
  inputId = "type",
  label = "Select the service types you would like displayed on the map:",
  choiceNames = list("Housing & Homelessness",
                     "Mental Health",
                     "Child & Family",
                     "Finance","Youth",
                     "Employment",
                     "Legal",
                     "Domestic & Family Violence",
                     "Information, advice & referral",
                     "Sexual Assault/Abuse",
                     "Health, Social Connection & Wellbeing",
                     "Migrant & Refugee",
                     "Alcohol & Drugs"),
  choiceValues= list("Housing_Homelessness","Mental_Health","Child_Family","Finance","Youth","Employment",
                     "Legal","Domestic_Family_Violence","Information_Advice_Referral", "Sexual_Assault_Abuse",
                     "Health_Social_Connection_Wellbeing","Migrant_Refugee","Alcohol_Drugs"),
  
  status = "primary", direction = "vertical", individual=TRUE,
  checkIcon = list(yes = icon("ok", lib = "glyphicon"), no = icon("remove", lib = "glyphicon"))
),



myicons <- iconList(
  Information_Advice_Referral = makeIcon("noun_advice_black.png",iconWidth = 52, iconHeight = 52),
  Youth = makeIcon("noun_Children_black.png",iconWidth = 8, iconHeight = 8),
  Child_Family = makeIcon("noun_Family_black.png",iconWidth = 8, iconHeight = 8),
  Finance = makeIcon("noun_finance_black.png",iconWidth = 8, iconHeight = 8),
  Health_Social_Connection_Wellbeing = makeIcon("noun_Fitness_149855.png",iconWidth = 52, iconHeight = 52),
  Housing_Homelessness = makeIcon("noun_Housing_black.png",iconWidth = 8, iconHeight = 8),
  Legal = makeIcon("noun_Law_black.png",iconWidth = 8, iconHeight = 8),
  Mental_Health = makeIcon("noun_Mental Health_black.png",iconWidth = 8, iconHeight = 8),
  Migrants_Refugees = makeIcon("noun_resettlement_black.png",iconWidth = 8, iconHeight = 8),
  Sexual_Assault_Abuse = makeIcon("noun_Sexual Harassment_black.png",iconWidth = 8, iconHeight = 8),
  Family_Violence = makeIcon("noun_shout_black.png",iconWidth = 8, iconHeight = 8),
  Employment = makeIcon("noun_Work_black.png",iconWidth = 8, iconHeight = 8),
  Alcohol_Drugs = makeIcon("noun_No Alcohol_1272614.png",iconWidth = 8, iconHeight = 8)
  
)










#population per electorate by age and sex
output$ageBar <- renderPlotly({
  
  ageplot<-ggplot(
    subset(df.age,df.age$Elect_div==input$division),
    aes(variable2, value)) + geom_bar(stat = "identity", position ="stack", aes(fill = variable3))+
    scale_x_discrete(labels=c("0-4","5-9","10-14","15-19","20-24","25-29","30-34", "35-39","40-44", 
                              "45-49","50-54","55-59","60-64","65-69", 
                              "70-74","75-79", "80-84",">85")) +
    theme_classic() + scale_fill_manual(values = MF, guide=FALSE) +
    theme(axis.text.x = element_text(angle=45, hjust = 1, size = 8, face= 'bold'))+
    labs(title = "Population", subtitle = "Data from ABS", x = "", y = "", fill= "Sex")
  
  ggplotly(ageplot)%>% config(displayModeBar = F) %>% layout(xaxis=list(fixedrange=TRUE)) %>% layout(yaxis=list(fixedrange=TRUE)) })



#tabPenel income
#weekly income per CED by Sex 
output$CED_income <- renderPlotly({
  incplot<-ggplot(
    subset(df.income,df.income$Elect_div==input$division),
    aes(x=fct_inorder(variable2),y= value)) + geom_bar(stat = "identity", position ="stack", aes(fill = variable3))+
    scale_x_discrete(labels=c("$1-149","$150-299","$300-399","$400-499","$500-649", "$650-799", "$800-999", "$1000-1249", "$1250-1499", "$1500-1749",
                              "$1750-1999", "$2000-2999", ">$3000"))+
    theme_classic() + scale_fill_manual(values = MF, guide=FALSE)+
    theme(axis.text.x = element_text(angle=45, hjust = 1,size = 8, face= 'bold'))+
    labs(title = "Weekly personal income",  subtitle = "Data from ABS",x = "", y = "", fill="Sex")
  ggplotly(incplot)%>% config(displayModeBar = F) %>% layout(xaxis=list(fixedrange=TRUE)) %>% layout(yaxis=list(fixedrange=TRUE)) }) 

output$AUS_income <- renderPlotly({
  aus_incplot<-ggplot(
    subset(df.income,df.income$Elect_div==input$division),
    aes(x=fct_inorder(variable2),y= value)) + geom_bar(stat = "identity", position ="stack", aes(fill = variable3))+
    scale_x_discrete(labels=c("$1-149","$150-299","$300-399","$400-499","$500-649", "$650-799", "$800-999", "$1000-1249", "$1250-1499", "$1500-1749",
                              "$1750-1999", "$2000-2999", ">$3000"))+
    theme_classic() + scale_fill_manual(values = MF, guide=FALSE)+
    theme(axis.text.x = element_text(angle=45, hjust = 1,size = 8, face= 'bold'))+
    labs(title = "Weekly personal income",  subtitle = "Data from ABS",x = "", y = "", fill="Sex")
  ggplotly(aus_incplot)%>% config(displayModeBar = F) %>% layout(xaxis=list(fixedrange=TRUE)) %>% layout(yaxis=list(fixedrange=TRUE)) }) 

output$QLD_income <- renderPlotly({
  qld_incplot<-ggplot(
    subset(df.income,df.income$Elect_div==input$division),
    aes(x=fct_inorder(variable2),y= value)) + geom_bar(stat = "identity", position ="stack", aes(fill = variable3))+
    scale_x_discrete(labels=c("$1-149","$150-299","$300-399","$400-499","$500-649", "$650-799", "$800-999", "$1000-1249", "$1250-1499", "$1500-1749",
                              "$1750-1999", "$2000-2999", ">$3000"))+
    theme_classic() + scale_fill_manual(values = MF, guide=FALSE)+
    theme(axis.text.x = element_text(angle=45, hjust = 1,size = 8, face= 'bold'))+
    labs(title = "Weekly personal income",  subtitle = "Data from ABS",x = "", y = "", fill="Sex")
  ggplotly(qld_incplot)%>% config(displayModeBar = F) %>% layout(xaxis=list(fixedrange=TRUE)) %>% layout(yaxis=list(fixedrange=TRUE)) }) 


selectInput("division", "",
            label="Select an electorate, graphs will be updated.",
            choices = qld.stats$Elect_div), 
plotlyOutput("ageBar"), plotlyOutput("eduBar")),

selectInput("division", "",
            label="Select an electorate, graphs will be updated.",
            choices = qld.stats$Elect_div), 
plotlyOutput("CED_income"),plotlyOutput("AUS_income"),plotlyOutput("QLD_income")),




qld_age_reactive<-reactive({
  if (input$View=="Absolute_Numbers"){qld.age$View<-qld.age$Absolute_Numbers} else{
    qld.age$View<-qld.age$Percentages
  }
  qld.age
})
observe(print(qld_age_reactive()))

#population for QLD by age and sex
output$age_qld <- renderPlotly({
  
  ageQld<-ggplot(data=qld_age_reactive(), aes(x=variable2, y=View)) + geom_bar(stat = "identity", position ="stack", aes(fill = variable3))+
    scale_x_discrete(labels=c("0-4","5-9","10-14","15-19","20-24","25-29","30-34", "35-39","40-44", 
                              "45-49","50-54","55-59","60-64","65-69", 
                              "70-74","75-79", "80-84",">85")) +
    theme_classic() + scale_fill_manual(values = MF, guide=FALSE) +
    theme(axis.text.x = element_text(angle=45, hjust = 1, size = 8, face= 'bold'))+
    labs(title = "State Population", subtitle = "Data from ABS", x = "", y = "", fill= "Sex")
  
  ggplotly(ageQld)%>% config(displayModeBar = F) %>% layout(xaxis=list(fixedrange=TRUE)) %>% layout(yaxis=list(fixedrange=TRUE))  })

#population for AUS by age and sex
output$age_aus <- renderPlotly({
  
  ageAus<-ggplot(data=aus.age, aes_string(x=variable2, y=Absolute_Numbers)) + geom_bar(stat = "identity", position ="stack", aes(fill = variable3))+
    scale_x_discrete(labels=c("0-4","5-9","10-14","15-19","20-24","25-29","30-34", "35-39","40-44", 
                              "45-49","50-54","55-59","60-64","65-69", 
                              "70-74","75-79", "80-84",">85")) +
    theme_classic() + scale_fill_manual(values = MF, guide=FALSE) +
    theme(axis.text.x = element_text(angle=45, hjust = 1, size = 8, face= 'bold'))+
    labs(title = "Australian Population", subtitle = "Data from ABS", x = "", y = "", fill= "Sex")
  
  ggplotly(ageAus)%>% config(displayModeBar = F) %>% layout(xaxis=list(fixedrange=TRUE)) %>% layout(yaxis=list(fixedrange=TRUE)) })





observe({
  
  leafletProxy("map", data = logan_sa2) %>%
    clearMarkers() %>%
    addMarkers(data = marker_data(),lat = ~Latitude,
               lng = ~Longitude)
  
})

marker_data <- reactive({
  services[services$Level_of_support %in% input$Type,]
})


services_factor$Level_of_support<-as.character(services_factor$Level_of_support)

getColor <- function(services) {
  sapply(services_factor$Level_of_support, function(Level_of_support) {
    if(Level_of_support == "Early Intervention & Prevention") {
      "green"
    } else if(Level_of_support == "Tertiary") {
      "pink"
    } else if(Level_of_support == "Secondary") {
      "blue"
    } else {
      "red"
    } })
}

icons <- awesomeIcons(
  icon = 'heart',
  iconColor = 'black',
  library = 'ion',
  markerColor = getColor(services_factor)
)

#we are adding a legend to display the raw data that aligns with the spatially depicted stat from the stats drop-down
#this information is also displayed in the pop-ups for each clickable electorate

#varname<-switch(input$type,
#                "Housing_Homelessness"="Housing & Homelessness",
#                 "Mental_Health" ="Mental Health",
#                 "Child_Family"="Child & Family",
#                "Finance"="Finance", 
#               "Youth"="Youth",
#              "Employment"="Employment",
#               "Legal"="Legal", 
#               "Domestic_Family_Violence"="Domestic & Family Violence",
#               "Information_Advice_Referral"="Information, advice & referral",
#               "Sexual_Assault_Abuse"="Sexual Assault/Abuse",
#               "Health_Social_Connection_Wellbeing"="Health, Social Connection & Wellbeing",
#               "Migrant_Refugee"="Migrant & Refugee",
#               "Alcohol_Drugs"="Alcohol & Drugs")


#leafletProxy("map", data = logan_sa2) %>% clearControls() %>%
#  addLegend(pal = pal2, opacity = 0.9, title = varname,
#           values = ~services[[input$SA2]],labels = c(min(input$SA2), max(input$SA2)),
#          position = "topright")
#})


services<-read.csv("data/Logan_Service_Locations.csv")
sec_serv<-services %>% filter (Level_of_support == "Secondary")
sec_serv_marker<-sec_serv[,12:18]
early_serv<-services %>% filter (Level_of_support == "Early Intervention & Prevention ")
early_serv_marker<-sec_serv[,12:18]
tert_serv<-services %>% filter (Level_of_support == "Tertiary")
tert_serv_marker<-sec_serv[,12:18]


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#read in language spoken at home data from 2011 and 2016
#we are only going to grab the person level data and not worry about the sex break-downs
#we are going to process this sa2 level data so that we can create a slope grap to show how the language landscape has changed overtime

library(dplyr);library(data.table); library(sqldf); library(ggplot2)

#read in data - downloaded from AURIN but also available from the ABS census TableBuilder tool which is free to use
lang11<-read.csv("data/Lang_at_Home_sa2_2011.csv")
lang16<-read.csv("data/Lang_at_Home_sa2_2016_qld.csv")
#only keep the person level data not the sex breakdown
#2011~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
lang11_p <- lang11 %>% dplyr:: select(ends_with("_P"))
lang11_per <- lang11 %>% dplyr:: select(ends_with("_Persons"))
lang11_sa2 <- lang11 %>% dplyr:: select(ends_with("_NAME11"))
#add the columns for SEO Persons and SA2 NAME to the lang11_p dataframe
lang11_p$SEO_Persons=lang11_per$SEO_Persons
lang11_p$SA2=lang11_sa2$SA2_NAME11

#set to df
lang11_p<-as.data.frame(lang11_p)
#fix up the names of the columns
colnames(lang11_p)[50]<-"SEO_Persons"
colnames(lang11_p)[51]<-"SA2_NAME11"
#only select the cols which we need and which match between the years 2011 and 2016
lang11_p<- sqldf("select SOL_Macedonian_P, SOL_Chin_lang_Mand_P, SOL_French_P, SOL_Arabic_P, SOL_Maltese_P, SOL_Dutch_P, SOL_Tamil_P,
            SOL_Italian_P, SOL_Se_As_A_L_Indon_P, SOL_Samoan_P, SOL_Japanese_P, SOL_Korean_P,SOL_Polish_P,
            SOL_In_Ar_Lang_Urdu_P, SOL_In_Ar_Lang_Sinh_P, SOL_Aus_Indig_Lang_P,SOL_Ir_La_Pe_excl_Da_P,
            SOL_Spanish_P,  SOL_In_Ar_Lang_Hind_P, SOL_Serbian_P, SOL_Turkish_P, SOL_Greek_P, SOL_Se_As_A_L_Tagal_P, 
            SOL_In_Ar_Lang_Beng_P, SOL_Thai_P, SOL_Vietnamese_P, SOL_Se_As_A_L_Filipino_P, SOL_In_Ar_Lang_Punj_P, SOL_Croatian_P,
            SOL_Russian_P,SOL_Chin_lang_Cant_P, SOL_German_P, SA2_NAME11 from lang11_p") 


#2016~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
lang16_p <- lang16 %>% dplyr:: select(ends_with("_p"))
lang16_sa2 <- lang16 %>% dplyr:: select(ends_with("_NAME16"))
#add the columns for SEO Persons and SA2 NAME to the lang11_p dataframe
lang16_p$SA2=lang16_sa2$sa2_name16

#set to df
lang16_p<-as.data.frame(lang16_p)

str(lang16_p)
str(lang11_p)
#fix up the names of the columns so that the two dfs match
#they need to match for when we melt and then join the two to create the slope graph
colnames(lang16_p)[1]<-"SOL_Macedonian_P"
colnames(lang16_p)[2]<-"SOL_Chin_lang_Mand_P"
colnames(lang16_p)[3]<-"SOL_French_P"
colnames(lang16_p)[5]<-"SOL_Arabic_P"
colnames(lang16_p)[6]<-"SOL_Maltese_P"
colnames(lang16_p)[7]<-"SOL_Dutch_P"
colnames(lang16_p)[8]<-"SOL_Tamil_P"
colnames(lang16_p)[9]<-"SOL_Italian_P"
colnames(lang16_p)[10]<-"SOL_Se_As_A_L_Indon_P"
colnames(lang16_p)[11]<-"SOL_Samoan_P"
colnames(lang16_p)[12]<-"SOL_Japanese_P"
colnames(lang16_p)[15]<-"SOL_Korean_P"
colnames(lang16_p)[16]<-"SOL_Polish_P"
colnames(lang16_p)[20]<-"SOL_In_Ar_Lang_Urdu_P"
colnames(lang16_p)[22]<-"SOL_In_Ar_Lang_Sinh_P"
colnames(lang16_p)[24]<-"SOL_Aus_Indig_Lang_P"
colnames(lang16_p)[25]<-"SOL_Ir_La_Pe_excl_Da_P"
colnames(lang16_p)[26]<-"SOL_Spanish_P"
colnames(lang16_p)[28]<-"SOL_In_Ar_Lang_Hind_P"
colnames(lang16_p)[29]<-"SOL_Serbian_P"
colnames(lang16_p)[30]<-"SOL_Turkish_P"
colnames(lang16_p)[31]<-"SOL_Greek_P"
colnames(lang16_p)[32]<-"SOL_Se_As_A_L_Tagal_P"
colnames(lang16_p)[33]<-"SOL_In_Ar_Lang_Beng_P"
colnames(lang16_p)[34]<-"SOL_Thai_P"
colnames(lang16_p)[35]<-"SOL_Vietnamese_P"
colnames(lang16_p)[37]<-"SOL_Se_As_A_L_Filipino_P"
colnames(lang16_p)[38]<-"SOL_In_Ar_Lang_Punj_P"
colnames(lang16_p)[39]<-"SOL_Croatian_P"
colnames(lang16_p)[42]<-"SOL_Russian_P"
colnames(lang16_p)[43]<-"SOL_Chin_lang_Cant_P"
colnames(lang16_p)[44]<-"SOL_German_P"

#remove unneccessary cols and those that dont match between the years
lang16_p[4]<-NULL
lang16_p[12]<-NULL
lang16_p[12]<-NULL
lang16_p[15]<-NULL
lang16_p[15]<-NULL
lang16_p[31]<-NULL
lang16_p[34]<-NULL
lang16_p[38]<-NULL
lang16_p[14]<-NULL
lang16_p[15]<-NULL
lang16_p[16]<-NULL
lang16_p[19]<-NULL
lang16_p[30]<-NULL


#get ready to bind the two years together
#create a year column
lang16_p$Year<-"2016"
lang11_p$Year<-"2011"
#rename the sa2 col before the rbind (append)
colnames(lang16_p)[33]<-"SA2_NAME11"
#rbind the two years 
lang_11_16 <- rbind(lang11_p, lang16_p)


#filter to only have the Sa2s in Logan as per the Logan Togther map
logan_lang_11_16<-lang_11_16[lang_11_16$SA2_NAME11 %in% c( "Jimboomba","Marsden","Regents Park - Heritage Park", "Arundel", 
                                                            "Crestmead","Rochedale South - Priestdale","Woodridge", "Eight Mile Plains",
                                                            "Eagleby","Greenbank","Loganholme - Tanah Merah","Boronia Heights - Park Ridge",
                                                            "Kingston (Qld.)","Loganlea","Slacks Creek","Bethania - Waterford",
                                                            "Shailer Park","Edens Landing - Holmview","Browns Plains",
                                                            "Hillcrest","Springwood","Waterford West","Underwood","Beenleigh",
                                                            "Cornubia - Carbrook","Logan Central","Daisy Hill","Wolffdene - Bahrs Scrub",
                                                            "Logan Village","Mount Warren Park", "Greenbank Military Camp",
                                                            "Chambers Flat - Logan Reserve","Munruben - Park Ridge South", "Rochedale - Burbank", "Sheldon - Mount Cotton"),]

#tes on one sa2 - Jimboomba as on the dashboard this will be interactive
jim_lang_11_16<-logan_lang_11_16[logan_lang_11_16$SA2_NAME11 == "Jimboomba",]
#melt the data into long format for the graph
jim_lang_11_16<-melt(jim_lang_11_16, id.vars= c("SA2_NAME11", "Year"))


logan_lang_melt<-melt(logan_lang_11_16, id.vars= c("SA2_NAME11", "Year"))

write.csv(logan_lang_melt, file="Logan_sa2_language.csv")

mycol1<-colorRampPalette(c("#311847","#B3001B", "#5fad56", "#f79256","#99d5c9","#87479c","#f16c67"))

ggplot(data = jim_lang_11_16, aes(x =Year, y = value, group = variable)) +
  geom_line(aes(color = variable, alpha = 1), size = 2) +
  geom_point(aes(color = variable, alpha = 1), size = 4) +
  # move the x axis labels up top
  scale_x_discrete(position = "top")+scale_color_manual(values =mycol1(33)) +
  theme_bw() +
  # Format tweaks
  # Remove the legend
  theme(legend.position = "bottom") +
  # Remove the panel border
  theme(panel.border = element_blank())+
  #labels for 2016 y axis
  geom_text(data = subset(jim_lang_11_16, Year == 2016 & value >= 35), 
            aes(x = as.factor(Year), y=value, color=variable, label = variable), 
            size = 3, hjust = -0.1)+
  labs(title = "Linguistic shifts between 2011 - 2016 per SA2", 
       y = "# people speaking a language other than English at home")





#creating the lables for the pop-ups on each clickable map-shape (polygon)

labels <- sprintf(
  "<strong>%s</strong><br/>
      Current elected candidate: %s <br/><br/>
      Sitting party: %s <br/><br/>
      Percentage of vote recieved: %s<br/><br/>", 
  sed.stats$SED_2018, sed.stats$Elected_candidate, sed.stats$Party, sed.stats$Pct_vote) %>% lapply(htmltools::HTML)

#we are adding a legend to display the raw data that aligns with the spatially depicted stat from the stats_input drop-down
#this information is also displayed in the pop-ups for each clickable electorate
varname<-switch(input$division_input,
                "Party"="Sitting party", 
                "Elected_candidate"="Current elected candidate",
                "Pct_vote"= "Percentage of vote recieved"
)


leafletProxy("map", data = sed.stats) %>% clearControls() %>%
  addLegend(pal = pal, opacity = 0.9, title = varname,
            values = ~sed.stats[[input$division_input]],labels = c(min(input$division_input), max(input$division_input)),
            position = "topright")


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#       COMPARE YOUR ELECTORATE TAB
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

df_age_reactive<-reactive ({
  c<-subset(df.age, SED_NAME18==input$division_input3)%>% #subset based on used input
    mutate(pop_total = sum(value))%>%
    group_by(SED_NAME18,variable2) %>% 
    #arrange(variable3) %>%
    mutate(pct_value = value / pop_total*100)%>%
    mutate(pos_scaled = cumsum(pct_value) - pct_value / 2,
           perc_text = paste0(round(pct_value, digits = 2), "%"))
  return(c)
})

#create percentages 
df_age_comp<-reactive ({
  d<-df.age[df.age$SED_NAME18 %in% c("Queensland" & "Australia"),]%>% 
    mutate(pop_total = sum(value))%>%
    group_by(SED_NAME18,variable2) %>% 
    #arrange(variable3) %>%
    mutate(pct_value = value / pop_total*100)%>%
    mutate(pos_scaled = cumsum(pct_value) - pct_value / 2,
           perc_text = paste0(round(pct_value, digits = 2), "%"))
  return(d)
})


#~~~~~~~~~~~~


#population comparing SED, QLD and National figures ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
output$age_plot <- renderPlotly({
  age_bar<-ggplot()+#subset(df.age, df.age$SED_NAME18 == input$division_input3),
    #mapping=aes(x=variable2, y=value,text = paste("Value:", value))) + 
    geom_col(data=df_age_comp(), 
             aes(x=variable2, y=pct_value, group = SED_NAME18,
                 text = paste("Value:", perc_text, "Location:", SED_NAME18),
                 fill= variable3,
                 #fill = factor(variable3, levels=c("male", "female")),install
                 alpha= 0.6),
             #order = variable3),
             position="dodge")+
    geom_point(data= df_age_comp(),
               aes(x=variable2, y=pct_value,
                   text = paste("Value:", perc_text, "Location:", SED_NAME18),
                   color = factor(variable3, levels=c("male", "female")),
                   # color= variable2,
                   alpha= 0.6),
               #order = variable3),
               position = "dodge")+
    scale_x_discrete(labels=c("0-4","5-9","10-14","15-19","20-24","25-29","30-34", "35-39","40-44", 
                              "45-49","50-54","55-59","60-64","65-69", 
                              "70-74","75-79", "80-84","85-89","90-94", "95-99", "100+")) +
    theme_classic() + theme(legend.position="right")+
    #scale_color_manual(values = MF, guide=FALSE) +
    #scale_fill_manual(values=scales::hue_pal()(21),
    # breaks=c("male",
    # "female"))+
    theme(axis.text.x = element_text(angle=45, hjust = 1, size = 8, face= 'bold'))+ 
    labs(title = "Population",  subtitle = "Data from ABS", x = "", y = "")
  ggplotly(age_bar, tooltip=c("text"))%>% config(displayModeBar = F) %>% layout(xaxis=list(fixedrange=TRUE)) %>% layout(yaxis=list(fixedrange=TRUE)) })  




#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#KINDY ENROLMENTS
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#read in csv for 2018
kindy_18<-read.csv("data/2018_sa2_kindy_enrolments.csv")
#check
str(kindy_18)
#rename sa2 col for merging
colnames(kindy_18)[4]<-"enrolments_address_2018"
colnames(kindy_18)[5]<-"enrolments_service_loc_2018"
str(kindy_18)

#read in csvs for 2017
kindy_17<-read.csv("data/2017_sa2_kindy_enrolments.csv")
str(kindy_17)
colnames(kindy_17)[3]<-"SA2_NAME16"
colnames(kindy_17)[4]<-"enrolments_address_2017"
colnames(kindy_17)[5]<-"enrolments_service_loc_2017"
str(kindy_17)

#read in csv for 2016
kindy_16<-read.csv("data/2016_sa2_kindy_enrolments.csv")
str(kindy_16)
colnames(kindy_16)[1]<-"SA2_NAME16"
colnames(kindy_16)[2]<-"enrolments_address_2016"
colnames(kindy_16)[3]<-"enrolments_service_loc_2016"
str(kindy_16)

#merge on sa2
kindy_16_17_18<-merge(kindy_16, kindy_17, by = "SA2_NAME16")
kindy_16_17_18<-merge(kindy_16_17_18, kindy_18, by = "SA2_NAME16")
#check
str(kindy_16_17_18)
#remove cols we dont need
kindy_16_17_18$Year.x<-NULL
kindy_16_17_18$Year.y<-NULL
kindy_16_17_18$SA.2.Main.Code<-NULL
kindy_16_17_18$SA2_MAIN16<-NULL
str(kindy_16_17_18)


#filter to only have the Sa2s in Logan as per the Logan Togther map
kindy_logan<-kindy_16_17_18[kindy_16_17_18$SA2_NAME16 %in% c("Jimboomba","Marsden","Regents Park - Heritage Park", "Arundel", 
                                                           "Crestmead","Rochedale South - Priestdale","Woodridge", "Eight Mile Plains",
                                                           "Eagleby","Greenbank","Loganholme - Tanah Merah","Boronia Heights - Park Ridge",
                                                           "Kingston (Qld.)","Loganlea","Slacks Creek","Bethania - Waterford",
                                                           "Shailer Park","Edens Landing - Holmview","Browns Plains",
                                                           "Hillcrest","Springwood","Waterford West","Underwood","Beenleigh",
                                                           "Cornubia - Carbrook","Logan Central","Daisy Hill","Wolffdene - Bahrs Scrub",
                                                           "Logan Village","Mount Warren Park", "Greenbank Military Camp",
                                                           "Chambers Flat - Logan Reserve","Munruben - Park Ridge South", "Rochedale - Burbank", "Sheldon - Mount Cotton"),]
str(kindy_logan)
levels(kindy_logan$SA2_NAME16)


write.csv(kindy_logan, file="Logan_SA2_Kindy_Enrolments_2016_2018.csv")
